SystemOrganization addCategory: #'Mondrian-Pharo-Tests'!

MondrianTest subclass: #MOCanvasTest
	instanceVariableNames: 'mouseDownEvents mouseUpEvents mouseMoveEvents mouseEnterEvents mouseLeaveEvents moCanvas aRoot v mouseEnterEventsSize mouseLeaveEventsSize mouseDownEventsSize mouseUpEventsSize mouseMoveEventsSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Tests'!

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:31'!
allEventPollsEmpty
	v := mouseEnterEvents isEmpty & 
		mouseLeaveEvents isEmpty & 
		mouseDownEvents isEmpty & 
		mouseUpEvents isEmpty & 
		mouseMoveEvents isEmpty.
	
	mouseEnterEventsSize := 0.
	mouseLeaveEventsSize := 0.
	mouseDownEventsSize := 0.
	mouseUpEventsSize := 0.
	mouseMoveEventsSize := 0.

	^ v! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:34'!
checkAllEventPollsEmpty
	self assert: (self allEventPollsEmpty) ! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:33'!
checkIfOneNewMouseDownEvent
	self assert: (mouseEnterEventsSize = mouseEnterEvents size).
	self assert: (mouseLeaveEventsSize = mouseLeaveEvents size).
	self assert: (mouseDownEventsSize = (mouseDownEvents size - 1)).
	self assert: (mouseUpEventsSize = mouseUpEvents size).
	self assert: (mouseMoveEventsSize = mouseMoveEvents size).

	mouseDownEventsSize := mouseDownEvents size! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:44'!
checkIfOneNewMouseEnterEvent
	self assert: (mouseEnterEventsSize =( mouseEnterEvents size -1) ).
	self assert: (mouseLeaveEventsSize = mouseLeaveEvents size).
	self assert: (mouseDownEventsSize = (mouseDownEvents size)).
	self assert: (mouseUpEventsSize = mouseUpEvents size).
	self assert: (mouseMoveEventsSize = mouseMoveEvents size).

	mouseEnterEventsSize := mouseEnterEvents size! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:33'!
checkIfOneNewMouseUpEvent
	self assert: (mouseEnterEventsSize = mouseEnterEvents size).
	self assert: (mouseLeaveEventsSize = mouseLeaveEvents size).
	self assert: (mouseDownEventsSize = (mouseDownEvents size)).
	self assert: (mouseUpEventsSize = (mouseUpEvents size - 1)).
	self assert: (mouseMoveEventsSize = mouseMoveEvents size).

	mouseUpEventsSize := mouseUpEvents size! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 6/27/2011 07:07'!
newButtonEvent
	^ (MouseButtonEvent new)
		setPosition: 1 @ 1;
		wasHandled: false;
		setType: #mouseEnter position: 1@1 buttons: 7 hand: nil
		 ! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:39'!
newMoveEvent
	^ self newMoveEventWithButtons: MouseEvent redButton
! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:39'!
newMoveEventWithButtons: buttons
	^ (MouseMoveEvent new)
		setType: #mouseMouse
			startPoint: 1 @ 1
			endPoint: 2 @ 2
			trail: #()
			buttons: buttons
			hand: ActiveHand
			stamp: Time millisecondClockValue;
		wasHandled: false! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:42'!
newMoveEventWithoutButton 
	^ self newMoveEventWithButtons: 0! !

!MOCanvasTest methodsFor: 'utils' stamp: 'AlexandreBergel 10/6/2010 10:30'!
oneNewMouseDownEvent
	! !

!MOCanvasTest methodsFor: 'running' stamp: 'AlexandreBergel 10/6/2010 10:24'!
setUp
	super setUp.

	mouseDownEvents := OrderedCollection new.
	mouseUpEvents := OrderedCollection new.
	mouseMoveEvents := OrderedCollection new.
	mouseEnterEvents := OrderedCollection new.
	mouseLeaveEvents := OrderedCollection new.

	aRoot := MORoot new.
	aRoot addNode: (MONode on: 'foobar').
	aRoot applyLayout.
	
	self assert: (aRoot bounds =  (0@0 corner: 10@10)).
	moCanvas := MOCanvas on: aRoot.
	moCanvas announcer on: MOMouseDown do: [:ann | mouseDownEvents add: ann].
	moCanvas announcer on: MOMouseUp do: [:ann | mouseUpEvents add: ann].
	moCanvas announcer on: MOMouseMove do: [:ann | mouseMoveEvents add: ann].
	moCanvas announcer on: MOMouseEnter do: [:ann | mouseEnterEvents add: ann].
	moCanvas announcer on: MOMouseLeave do: [:ann | mouseLeaveEvents add: ann].! !

!MOCanvasTest methodsFor: 'running' stamp: 'AlexandreBergel 10/6/2010 10:15'!
tearDown
	super tearDown.

	mouseDownEvents := nil.
	mouseUpEvents := nil.
	mouseMoveEvents := nil.
	mouseEnterEvents := nil.
	mouseLeaveEvents := nil.
! !

!MOCanvasTest methodsFor: 'basic' stamp: 'AlexandreBergel 10/6/2010 10:24'!
testBasic
	|  event |
	
	self assert: (moCanvas bounds = ( 0@0 corner: 10@10 )).
	
	self assert: (moCanvas handlesMouseOver: nil).
	self assert: (moCanvas handlesKeyboard: nil).
	self assert: (moCanvas handlesMouseDown: nil).
	! !

!MOCanvasTest methodsFor: 'size' stamp: 'AlexandreBergel 10/6/2010 10:11'!
testCanvasSize
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	view shape rectangle width: 40; height: 30.
	view node: #foo.
	
	self assert: (view root bounds = ( 0@0 corner: 40@30)).
	
	view root applyLayout.
	self assert: (view root bounds = ( 0@0 corner: 45@35)).
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = (0@0 corner: 45@35)).
	"self assert: canvas extent = scrollPane extent"! !

!MOCanvasTest methodsFor: 'size' stamp: 'AlexandreBergel 10/6/2010 10:11'!
testCanvasSize2
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	view shape rectangle width: 5; height: 5.
	view node: #foo.
	
	self assert: (view root bounds = ( 0@0 corner: 5@5)).
	
	view root applyLayout.
	self assert: (view root bounds = ( 0@0 corner: 10@10)).
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = ( 0@0 corner: 10@10)).
	"self assert: canvas extent = scrollPane extent"! !

!MOCanvasTest methodsFor: 'size' stamp: 'AlexandreBergel 10/6/2010 10:11'!
testCanvasSize3
	| view canvas scrollPane v wishedWindowBounds node |
	
	view := MOViewRenderer new.
	view node: 1 forIt: [
		view shape rectangle size: 30.
		view node: 2 ].
	
	window := view open.
	wishedWindowBounds :=  13@182 corner: 763@562.
	window doLayoutIn: wishedWindowBounds.
	
	canvas := window findDeeplyA: MOCanvas.
	scrollPane := window findDeeplyA: ScrollPane.
	v := scrollPane extent.
	self assert: v >= (700@300).
	self assert: (canvas bounds = ( 0@0 corner: 45@45)).
	
	node := view nodeForDomainValue: 1.
	node announce: ((MOMouseDrag event: nil on: node) step: -100 @ -100).
	self assert: (canvas bounds = ( 0@0 corner: 45@45)).! !

!MOCanvasTest methodsFor: 'size' stamp: 'AlexandreBergel 10/6/2010 10:11'!
testCanvasStretch
	| view canvas scrollPane v wishedWindowBounds |
	
	view := MOViewRenderer new.
	window := view open.
	
	self assert: (view root bounds = ( 0@0 corner: 5@5)).
	view root expandToIncludePoint: 100@30.
	self assert: (view root bounds = ( 0@0 corner: 100@30)).
	
	view root expandToIncludePoint: 10@20.
	self assert: (view root bounds = ( 0@0 corner: 100@30)).! !

!MOCanvasTest methodsFor: 'size' stamp: 'AlexandreBergel 6/27/2011 07:23'!
testCanvasStretchWithEvent
	| view canvas scrollPane wishedWindowBounds |
	
	view := MOViewRenderer new.
	window := view open.
	
	self assert: (view root bounds = ( 0@0 corner: 5@5)).
	view root expandForEvent: (MOMouseDown event: (MouseEvent new setPosition: 100@30; setType: #mouseEnter) on: nil).
	self assert: (view root bounds = ( 0@0 corner: 130@39)).
	
	view root expandForEvent: (MOMouseDown event: (MouseEvent new setPosition: 10@20; setType: #mouseEnter) on: nil).
	self assert: (view root bounds = ( 0@0 corner: 130@39)).! !

!MOCanvasTest methodsFor: 'events' stamp: 'AlexandreBergel 5/18/2011 16:01'!
testEventsFromCanvas
	| event |
	"Mouse button down"
	event := self newButtonEvent.
	self checkAllEventPollsEmpty.
	self deny: event wasHandled.
	moCanvas mouseDown: event.
	self assert: event wasHandled.	
	self checkIfOneNewMouseDownEvent.
	
	"Mouse button over with button"
	event := self newMoveEvent.
	self deny: event wasHandled.
	moCanvas mouseDown: event.
	self assert: event wasHandled.
	self checkIfOneNewMouseDownEvent.
			
	"Mouse button over without button"
	event := self newMoveEventWithoutButton.
	self deny: event wasHandled.
	self assert: mouseEnterEvents isEmpty.
	self assert: mouseLeaveEvents isEmpty.
	moCanvas mouseOver: event.
	self assert: event wasHandled.
	self checkIfOneNewMouseEnterEvent.
! !

MondrianTest subclass: #MOEaselTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Tests'!

!MOEaselTest methodsFor: 'util' stamp: 'AlexandreBergel 4/11/2011 15:57'!
getAllWindows
	^ World submorphs select: #isSystemWindow! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'Alexandre Bergel 3/4/2010 14:16'!
testAllVariableKeys
	| easel |
	easel := MOEasel new.
	self assert: (easel allVariableKeys includes: #view)! !

!MOEaselTest methodsFor: 'class initialize' stamp: 'AlexandreBergel 4/21/2011 10:07'!
testClassInitialize
	"This makes sure we will not get a bad surprise when installing Mondrian"
	
	self shouldnt:  [ MOEasel initialize ] raise:   Exception! !

!MOEaselTest methodsFor: 'testing help' stamp: 'AlexandreBergel 10/28/2010 00:44'!
testExamplesAreOkay
	| inst source view easel |
	inst := MOEaselExamples new.
	(MOEaselExamples selectors select: [ :sel | sel beginsWith: 'script']) do: [:sel |
		source := inst perform: sel.
		
		easel := MOEasel new. 
		window := easel open.
		easel setScript: source.
		easel generate.		
		window delete
	]! !

!MOEaselTest methodsFor: 'icon' stamp: 'AlexandreBergel 4/11/2011 16:18'!
testIcon
	self assert: MOEasel icon isForm! !

!MOEaselTest methodsFor: 'scripts' stamp: 'AlexandreBergel 4/11/2011 16:25'!
testNumberOfScripts
	| easel |

	easel := MOEasel new.
	self assert: (easel numberOfPreviousScripts isNumber).

	"The following does a global side effect"
"	easel storeScript: 'view node: #zork'.
	self assert: (easel numberOfPreviousScripts = 1).
	easel storeScript: 'view node: #zork'.
	self assert: (easel numberOfPreviousScripts = 1).
"! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'AlexandreBergel 4/11/2011 16:04'!
testOpen
	| easel |
	window := MOEasel open.
! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'AlexandreBergel 4/11/2011 15:56'!
testOpenAndClose
	| windows |
	
	windows := self getAllWindows.
	[ MOEasel new open; closeEasel ] valueSupplyingAnswer: true.
	self assert: (self getAllWindows = windows)! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'AlexandreBergel 4/11/2011 15:55'!
testOpenOn
	| easel |
	window := MOEasel openOn: #foo -> self.
	easel := window model.
	self assert: (easel allVariableKeys includes: #view).
	self assert: (easel allVariableKeys includes: #foo)! !

!MOEaselTest methodsFor: 'commands' stamp: 'AlexandreBergel 1/27/2011 09:41'!
testOpenTutorial
	"Check that the tutorial can be open"
	
	| helpBrowser |
	self shouldnt: [helpBrowser := MOEaselCommandTutorial new execute] raise: Error.
	helpBrowser ifNotNil: [helpBrowser close]! !

!MOEaselTest methodsFor: 'simple checks' stamp: 'AlexandreBergel 10/28/2010 01:12'!
testOpenWithTitle
	"This is supported only in Pharo 1.1"
	Smalltalk at: #SystemVersion ifPresent: [:cl |
			(cl current version beginsWith: 'Pharo') 
				ifTrue: [	
					(cl current perform:  #highestUpdate) <=  10517
						ifTrue: [ ^ self ] ] ].

	window := MOEasel openWithTitle: 'hello'.
	self assert: window label = 'hello'! !

!MOEaselTest methodsFor: 'scripts' stamp: 'AlexandreBergel 4/11/2011 16:34'!
testScripts
	| easel |

	easel := MOEasel new.
	window := easel open.
	self assert: easel text = ''.
	easel numberOfPreviousScripts isZero
		ifTrue: [ easel storeScript: 'view nodes: (1 to: 5)'.
				self assert: easel numberOfPreviousScripts = 1 ].
			
	easel setScriptNumber: 1.
	self assert: easel text = easel previousScripts first! !

!MOEaselTest methodsFor: 'resize' stamp: 'Alexandre Bergel 6/14/2010 16:56'!
testSize1
	| easel canvas scrollPanel wishedWindowBounds |
	easel := MOEasel new.
	window := easel open.
	wishedWindowBounds :=  13@182 corner: 763@562.

	"Small rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view node: #foo'.
	easel generate.
	window doLayoutIn: wishedWindowBounds.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	self assert: (canvas extent < scrollPanel extent).
	self deny: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self deny: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.


	"Big rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view nodes: (1 to: 100)'.
	easel generate.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	window doLayoutIn: wishedWindowBounds.
	
"	self assert: (canvas extent y = scrollPanel extent y).
	self assert: (canvas extent x > scrollPanel extent x).
"
	self assert: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self assert: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.

	"Small rendering"
	easel setScript: 'view shape rectangle width: 40; height: 30. view node: #foo'.
	easel generate.
	window doLayoutIn: wishedWindowBounds.
	canvas := window findDeeplyA: MOCanvas.
	scrollPanel := window findDeeplyA: ScrollPane.
	self assert: (canvas extent < scrollPanel extent).
	self deny: scrollPanel hIsScrollable.
	self deny: scrollPanel vIsScrollable.
	self deny: scrollPanel hIsScrollbarShowing.
	self deny: scrollPanel vIsScrollbarShowing.

! !
